

#include <allegro.h>
#include <iostream>
#include <vector>
#include <sstream>
#include <math.h>
#include <list>
#include <string>
#include <map>
#include <time.h>
#include <fstream>
#include <stack>
#include <algorithm>
#include <queue>
#ifdef __APPLE__
#include <ApplicationServices/ApplicationServices.h>
#endif

using namespace std;
#include "words.hpp"


typedef double num;

const int SCREEN_WIDTH=160;
const int SCREEN_HEIGHT=120;

const int RADIUS = 5;
const int BASERADIUS = 37;

const int QUICKWAIT=10;

struct Pos {
	float x;
	float y;
};

bool currentplayertimeleft;

enum GameState {
	GS_INTRO_GAMENAME,
	GS_INTRO_SCORES,
	GS_TITLE_NEWGAMEMENU,
	GS_TITLE_PLAYERNUMSELECT,
	GS_TITLE_RELATIONSHIPSELECT,
	GS_TITLE_WELCOME,
	GS_CONTINUE_ENTERTEAMNAME,
	GS_CONTINUE_NAMENOTFOUND,
	GS_CONTINUE_WELCOMEBACK,
	GS_GAME_LEVELX,
	GS_GAME_DESCRIPTION,
	GS_GAME_LOGBACKIN,
	GS_GAME_CONFIRMATION,
	GS_GAME_GAMEOVER,
	GS_GAME_SUCCESS,
    GS_GAME_GAMEOVER_SUCCESS,
    GS_GAME_GOODLUCK
};

char* GameStateName[100] = {
	"GS_INTRO_GAMENAME",
	"GS_INTRO_SCORES",
	"GS_TITLE_NEWGAMEMENU",
	"GS_TITLE_PLAYERNUMSELECT",
	"GS_TITLE_RELATIONSHIPSELECT",
	"GS_TITLE_WELCOME",
	"GS_CONTINUE_ENTERTEAMNAME",
	"GS_CONTINUE_NAMENOTFOUND",
	"GS_CONTINUE_WELCOMEBACK",
	"GS_GAME_LEVELX",
	"GS_GAME_DESCRIPTION",
	"GS_GAME_LOGBACKIN",
	"GS_GAME_CONFIRMATION",
	"GS_GAME_GAMEOVER",
	"GS_GAME_SUCCESS",
    "GS_GAME_GAMEOVER_SUCCESS",
    "GS_GAME_GOODLUCK"
};

GameState gamestate;

int magenta;
int red;
int black;
int white;
int green;
int blue;
int yellow;

int target[2];
bool inbase[2];

Pos pos[2];
Pos base[2];

const int CIRCLECOUNT=20;

Pos circles[CIRCLECOUNT];
Pos circelvels[CIRCLECOUNT];

int influencedcount[2];
bool influenced[CIRCLECOUNT];
int influencedtimer[CIRCLECOUNT];
Pos influencedpos[CIRCLECOUNT];
//used for targetting numerical enemies


BITMAP* buffer;


#include "sound.hpp"
#include "misc.hpp"
#include "timer.hpp"
#include "printwrap.hpp"


const int ts=13;
bool quit=false;
bool leave=false;
int titletimer=0;
bool finishedtitle;

bool escpressed;
bool apressed;

bool collided;

bool collides(Pos& a, Pos& b)
{
	float dx = (a.x-b.x);
	float dy = (a.y-b.y);

	return (dx*dx+dy*dy <= RADIUS*RADIUS);
}

bool showstory=false;

const char* storytext[7][4]=
{
{"Get all ball",
"before time runs out.",
"player 1: wsadyu",
"player 2: up/down/left/right/space/m"}
};

int score[2];
char scoretxt1[30];
char scoretxt2[30];
char timetext[30];
int gametimer;
const int FRAME_RATE=45;
bool spacepressed;
int storyprogress;
bool finishedstory;
bool endmode;
int pauseafter;

string edittext;
string screentext;

string::iterator iter = edittext.begin();   // string iterator
int caret=0;                               // tracks the text caret
bool insert=true;                         // true if text should be inserted

time_t tStart;
int tElapsed;

bool checkinput(){

	while(keypressed()){
        time(&tStart);
		//debugfile << "Keypressed! \n"; debugfile.flush();
		int  newkey   = readkey();
		char ASCII    = newkey & 0xff;
		char scancode = newkey >> 8;

		if((ASCII >= 65 && ASCII <= 90) || (ASCII >= 48 && ASCII <= 57) || (ASCII >= 97 && ASCII <= 122)){
			if(edittext.length()<=16){
				if(insert || iter == edittext.end()){
					iter = edittext.insert(iter, tolower(ASCII));
					iter++;
				}else{
					edittext.replace(caret, 1, 1, ASCII);

					caret++;
					iter++;
				}
			}
		}else{
			switch(scancode){
				case KEY_DEL:
					if(iter != edittext.end()) iter = edittext.erase(iter);
					break;
				case KEY_ENTER:
					if(edittext.length()>0){
                        return true;
						//On with the game!
						//do processing stuff
						while(key[KEY_ENTER]);
					}
					break;
				case KEY_BACKSPACE:
					if(iter != edittext.begin()){
						caret--;
						iter--;
						iter = edittext.erase(iter);
                    }
                    break;
				default:
					break;
			}
		}
	}

    screentext=edittext+'_';

	return false;
}


bool isvalidteamname(string s)
{
    NameDat nd;
    if (parsename(s,nd))
    {
        for (unsigned int i=0;i<progressdatas.size();i++)
        {
            if (progressdatas[i].namedat==nd)
            {
                curteam=i;
                return true;
            }
        }
        cout<<"ERRRRRR"<<endl;
        return false;
    }
    return false;
}


class TextEntryLoop
{
public:
	static void initialize()
	{
        time(&tStart);
		edittext.clear();
        iter = edittext.begin();
		screentext="_";
		finishedtitle=false;
	}
	static bool quitcondition()
	{
		return quit || finishedtitle;
	}
	static void logic()
	{
        time_t tCur;
        time(&tCur);
        double elapsed = difftime(tCur,tStart);
        tElapsed=floor(elapsed);

        if ( tElapsed>0 && 6-tElapsed < 0)
        {
            finishedtitle=true;
            gamestate=GS_INTRO_GAMENAME;
            return;
        }

		if (checkinput())
        {
            if (edittext=="quit")
            {
                exit(0);
            }
            else if (isvalidteamname(edittext))
            {
                if (progressdatas[curteam].task==ENDCHALLENGE)
                {
                    gamestate=GS_CONTINUE_NAMENOTFOUND;
                    finishedtitle=true;
                }
                else
                {
                    gamestate=GS_CONTINUE_WELCOMEBACK;
                    finishedtitle=true;
                }
            }
            else
            {
                gamestate=GS_CONTINUE_NAMENOTFOUND;
                finishedtitle=true;
            }
        }
	}
	static void draw()
	{
		clear_to_color(buffer, black);

		textout_centre_ex(buffer, font, "enter codeword:", 80, 40, makecol(255,255,255), makecol(0,0,0));
		textout_centre_ex(buffer, font, screentext.c_str(), 80, 60, makecol(255,255,255), -1);
	}

};

struct MenuStruct
{
	string selectiontext;
	vector<string> options;
};

MenuStruct newgamemenu;
MenuStruct playercountmenu;
MenuStruct relationshipmenu;

void initmenus()
{
	newgamemenu.selectiontext="HAPPENING GAME";
	newgamemenu.options.clear();
	newgamemenu.options.push_back("NEW GAME");
	newgamemenu.options.push_back("CONTINUE");

	playercountmenu.selectiontext="NUMBER OF PLAYERS";
	playercountmenu.options.clear();
	playercountmenu.options.push_back("1 PLAYER");
	playercountmenu.options.push_back("2 PLAYERS");

	relationshipmenu.selectiontext="SELECT RELATIONSHIP";
	relationshipmenu.options.clear();
	relationshipmenu.options.push_back("FAMILY");
	relationshipmenu.options.push_back("FRIENDS");
	relationshipmenu.options.push_back("LOVERS");
	relationshipmenu.options.push_back("STRANGERS");

}

int menuresult;

//up down left right space
enum keyPressed {
	KP_UP=0,
	KP_DOWN=1,
	KP_LEFT=2,
	KP_RIGHT=3,
	KP_SPACE=4,
	KP_A=5,
	KP_Z=6,
	KP_J=7,
	KP_M=8,
  	KP_ENTER=9,
};
bool pressed[10];

void initPressArray()
{
	for (int i=0;i<10;i++)
		pressed[i]=true;
}

int updatePressed()
{
#define PRESS_PATTERN(KEYNAME)					\
	if (key[KEY_##KEYNAME])						\
	{											\
		if(!pressed[KP_##KEYNAME])				\
		{										\
			pressed[KP_##KEYNAME]=true;			\
			return KEY_##KEYNAME;				\
		}										\
	}											\
	else										\
	{											\
		if (pressed[KP_##KEYNAME])				\
		{										\
			pressed[KP_##KEYNAME]=false;		\
		}										\
	}											\

	PRESS_PATTERN(UP);
	PRESS_PATTERN(DOWN);
	PRESS_PATTERN(LEFT);
	PRESS_PATTERN(RIGHT);
	PRESS_PATTERN(SPACE);
	PRESS_PATTERN(A);
	PRESS_PATTERN(Z);
	PRESS_PATTERN(J);
	PRESS_PATTERN(M);
	PRESS_PATTERN(ENTER);

	return -1;

#undef PRESS_PATTERN
}

bool bTimeout=false;

class SelectLoop
	{
	public:
		static MenuStruct* s;
		static int countdowntimer;
		static void initialize()
		{
            bTimeout=false;
            time(&tStart);
			finishedtitle=false;
			initPressArray();
			countdowntimer=-1;
			menuresult=0;
		}

		static bool quitcondition()
		{
			return quit || finishedtitle;
		}
		static void logic()
		{

            time_t tCur;
            time(&tCur);
            double elapsed = difftime(tCur,tStart);
            tElapsed=floor(elapsed);

            if ( tElapsed>0 && 10-tElapsed < 0)
            {
                finishedtitle=true;
                gamestate=GS_INTRO_GAMENAME;
                return;
            }

			if (countdowntimer>0)
			{
				countdowntimer--;
				if (countdowntimer==0)
				{
					finishedtitle=true;
				}
				return;
			}
            int key_pressed=updatePressed();
			while (key_pressed!=-1)
			{
				switch(key_pressed)
				{
					case KEY_UP:
						menuresult=(menuresult+s->options.size()-1)%s->options.size();
						break;
					case KEY_DOWN:
						menuresult=(menuresult+1)%s->options.size();
						break;
					case KEY_SPACE:
                    case KEY_ENTER:
						countdowntimer=QUICKWAIT;
						break;
				}

                key_pressed=updatePressed();
			}

		}
		static void draw()
		{
			clear_to_color(buffer, makecol(0,0,0));
			if (quit)
				return;

            textout_centre_ex(buffer, font, s->selectiontext.c_str(), 80, 20, makecol(100,100,100), makecol(0,0,0));

			for (unsigned int i=0;i<s->options.size();i++)
			{
                if (menuresult==i)
                    textout_centre_ex(buffer, font, ((string)"["+s->options[i]+"]").c_str(), 80, 50+15*i, makecol(255,255,100), makecol(0,0,0));

                else
                    textout_centre_ex(buffer, font, ((string)" "+s->options[i]+" ").c_str(), 80, 50+15*i, makecol(200,200,200), makecol(0,0,0));

			}


            stringstream s;
            s<<10-tElapsed;
		}
	};
MenuStruct* SelectLoop::s;
int SelectLoop::countdowntimer;

class StoryLoop
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			storyprogress=0;
			finishedstory=false;
			pauseafter=0;
			playmusic(13);
		}
		static bool quitcondition()
		{
			return quit && pauseafter==0;
		}
		static void logic()
		{

			if (pauseafter>0)
				pauseafter--;

			if (key[KEY_ESC]&&!escpressed)
				quit=true;

			if (key[KEY_SPACE]||key[KEY_ENTER])
			{
				quit=true;
			}
			else
			{
				spacepressed=false;
			}
		}
		static void draw()
		{
			clear_to_color(buffer, makecol(0,0,0));
			if (quit)
				return;

            textout_centre_ex(buffer, font, storytext[storyprogress][0], 160, 50, makecol(255,255,255), makecol(0,0,0));
			textout_centre_ex(buffer, font, storytext[storyprogress][1], 160, 65, makecol(255,255,255), makecol(0,0,0));
			textout_centre_ex(buffer, font, storytext[storyprogress][2], 160, 80, makecol(255,255,255), makecol(0,0,0));
			textout_centre_ex(buffer, font, storytext[storyprogress][3], 160, 95, makecol(255,255,255), makecol(0,0,0));

		}
	};

class IntroLoop1
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
            quit=false;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120)
			{
				finishedtitle=true;
                gamestate=GS_INTRO_SCORES;
			}
            if (key[KEY_SPACE]||key[KEY_ENTER])
            {
                finishedtitle=true;
                gamestate=GS_TITLE_NEWGAMEMENU;
            }
		}

		static void draw()
		{
		    clear_to_color(buffer,black);
			textout_centre_ex(buffer, font, "HAPPENING", 80, 40, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font, "GAME", 80, 60, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font, "press space to play", 80, 95, makecol(100,100,100), -1);
		}
	};

class IntroLoop2
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
            quit=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120)
			{
				finishedtitle=true;
                gamestate=GS_INTRO_GAMENAME;
			}
            if (key[KEY_SPACE]||key[KEY_ENTER])
            {
                finishedtitle=true;
                gamestate=GS_TITLE_NEWGAMEMENU;
            }
		}

		static void draw()
		{
		    clear_to_color(buffer,black);
			textout_centre_ex(buffer, font, "press space to play", 80, 95, makecol(100,100,100), -1);
		}
	};


class WelcomeLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
            progressdatas.push_back(ProgressData());
            curteam=progressdatas.size()-1;
            progressdatas[curteam].task=start[tempteamtype];
            progressdatas[curteam].confirmationseen=false;
            progressdatas[curteam].starttime=0;//FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120)
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,black);
			textout_centre_ex(buffer, font, "Welcome", 80, 30, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font, getName(progressdatas[curteam].namedat).c_str(), 80, 50, makecol(255,255,100), -1);
			textout_centre_ex(buffer, font, "to", 80, 70, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font, "Happening Game", 80, 90, makecol(100,100,100), -1);
		}
	};


class LevelIntroLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120)
			{
				finishedtitle=true;
			}
		}

		static void draw()
		{
            stringstream s;
            s<<"TASK ";
            s<<progressdatas[curteam].score;
		    clear_to_color(buffer,black);
            textout_ex(buffer, font, getName(progressdatas[curteam].namedat).c_str(), 10, 10, makecol(255,255,100), -1);
			textout_centre_ex(buffer, font, "GET READY FOR", 80, 40, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font,  s.str().c_str(), 80, 60, makecol(100,100,100), -1);
		}
	};


class NameNotFoundLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120)
			{
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,black);
			textout_centre_ex(buffer, font, "TEAM", 80, 40, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font, "NOT", 80, 55, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font, "FOUND", 80, 70, makecol(100,100,100), -1);
		}
	};


class WelcomeBackLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120)
			{
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,black);
			textout_centre_ex(buffer, font, "Welcome back", 80, 30, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font, getName(progressdatas[curteam].namedat).c_str(), 80, 50, makecol(255,255,100), -1);
			textout_centre_ex(buffer, font, "to", 80, 70, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font, "Happening Game", 80, 90, makecol(100,100,100), -1);
		}
	};



class LevelDescriptionLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>300)
			{
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,black);

            textout_ex(buffer, font, getName(progressdatas[curteam].namedat).c_str(), 10, 10, makecol(255,255,100), -1);

            stringstream s;
            s<<"TASK ";
            s<<progressdatas[curteam].score;
            s<<":";
            if (titletimer>10)
                textout_centre_ex(buffer, font,  s.str().c_str(), 80, 25, makecol(100,100,100), -1);

            if (titletimer>40)
                wrapprint(challenges[progressdatas[curteam].task].pretext, 10, 50, 18);
		}
	};



class CallBackLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120)
			{
				finishedtitle=true;
                gamestate=GS_GAME_GOODLUCK;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,black);
			textout_centre_ex(buffer, font, "Log in again as", 80, 20, makecol(100,100,100), -1);
            textout_centre_ex(buffer, font, getName(progressdatas[curteam].namedat).c_str(), 80, 40, makecol(255,255,100), -1);
			textout_centre_ex(buffer, font, "when the task", 80, 60, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font, "is completed.", 80, 80, makecol(100,100,100), -1);
		}
	};



class GoodLuckLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120)
			{
				finishedtitle=true;
                gamestate=GS_INTRO_GAMENAME;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,black);
			textout_centre_ex(buffer, font, "Good Luck!", 80, 40, makecol(100,100,100), -1);
		}
	};

int confirm[2];

class ConfirmationLoop
	{
	public:

		static void initialize()
		{
            time(&tStart);
            confirm[0]=0;
            confirm[1]=0;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
            time_t tCur;
            time(&tCur);
            double elapsed = difftime(tCur,tStart);
            tElapsed=floor(elapsed);

            if (titletimer==0 && tElapsed>0 && 30-tElapsed < 0)
            {
                finishedtitle=true;
                return;
            }

            int key_pressed=updatePressed();
			while (key_pressed!=-1)
            {
                switch(key_pressed)
                {
                    case KEY_A:
                        if (confirm[0]==0)
                            confirm[0]=1;
                        break;
                    case KEY_Z:
                        if (confirm[0]==0)
                            confirm[0]=-1;
                        break;
                    case KEY_J:
                        if (confirm[1]==0)
                            confirm[1]=1;
                        break;
                    case KEY_M:
                        if (confirm[1]==0)
                            confirm[1]=-1;
                        break;
                }
                key_pressed=updatePressed();
            }


            if (confirm[0]!=0 && confirm[1]!=0)
            {
                titletimer++;

                if (titletimer>30)
                {
                    finishedtitle=true;
                    if (confirm[0]==1 && confirm[1]==1)
                    {
                        if (progressdatas[curteam].task==SINGLEPLAYERCHALLENGE)
                        {
                            playeraddition=true;
                        }
                        else
                        {
                            progressdatas[curteam].score++;
                            playeraddition=false;
                            if (challenges[progressdatas[curteam].task].nextchallenge==ENDCHALLENGE)
                            {
                                progressdatas[curteam].task=ENDCHALLENGE;
                            }
                            else
                            {
                                progressdatas[curteam].task++;
                            }
                            progressdatas[curteam].confirmationseen=false;
                            save();
                        }

                        if (progressdatas[curteam].task==ENDCHALLENGE)
                            gamestate=GS_GAME_GAMEOVER_SUCCESS;
                        else
                            gamestate=GS_GAME_SUCCESS;
                    }
                }
            }
		}

		static void draw()
		{
            if (titletimer==0)
                clear_to_color(buffer,black);
            else
                clear_to_color(buffer, makecol(0,0,100));

            if (progressdatas[curteam].task!=ENDCHALLENGE)
            {
                textout_ex(buffer, font, getName(progressdatas[curteam].namedat).c_str(), 10, 10, makecol(255,255,100), -1);

                wrapprint(challenges[progressdatas[curteam].task].posttext, 10, 25, 18);
            }

            int col1y = confirm[0]==1 ? makecol(100,255,100) : makecol(100,100,100);
            int col1n = confirm[0]==-1 ? makecol(255,100,100) : makecol(100,100,100);
            int col2y = confirm[1]==1 ? makecol(100,255,100) : makecol(100,100,100);
            int col2n = confirm[1]==-1 ? makecol(255,100,100) : makecol(100,100,100);

			textout_ex(buffer, font, "PLAYER 1", 5, 78, makecol(100,100,100), -1);
			textout_ex(buffer, font, "A - YES", 5, 96, col1y, -1);
			textout_ex(buffer, font, "Z - NO", 5, 106, col1n, -1);

            textout_right_ex(buffer, font, "PLAYER 2", 160-5, 78, makecol(100,100,100), -1);
			textout_right_ex(buffer, font, "YES - J", 160-5, 96, col2y, -1);
			textout_right_ex(buffer, font, "NO - M", 160-5, 106, col2n, -1);

            stringstream s;
            s<<30-tElapsed;

            if (tElapsed>20)
                textout_right_ex(buffer, font,s.str().c_str(), 160-5, 10, makecol(255,100,100), -1);
            else
                textout_right_ex(buffer, font,s.str().c_str(), 160-5, 10, makecol(100,100,100), -1);
        }
    };


class GameOverLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120)
			{
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,black);
            textout_ex(buffer, font, getName(progressdatas[curteam].namedat).c_str(), 10, 10, makecol(255,255,100), -1);
            textout_ex(buffer, font, getName(progressdatas[curteam].namedat).c_str(), 10, 10, makecol(255,255,100), -1);
			textout_centre_ex(buffer, font, "confirmation failed", 80, 55, makecol(100,100,100), -1);
		}
	};



class SuccessLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120)
			{
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,black);
            stringstream s;
            s<<"TASK ";
            s<<progressdatas[curteam].score-1;

			textout_centre_ex(buffer, font, "CONGRATULATIONS", 80, 20, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font, "Success for", 80, 40, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font, s.str().c_str(), 80, 60, makecol(100,100,100), -1);
			textout_centre_ex(buffer, font, "confirmed.", 80, 80, makecol(100,100,100), -1);
		}
	};


class GameoverSuccessLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>300)
			{
				finishedtitle=true;
                gamestate=GS_INTRO_GAMENAME;
			}
            if ((key[KEY_SPACE]||key[KEY_ENTER]) && titletimer>50)
            {
                finishedtitle=true;
                gamestate=GS_TITLE_NEWGAMEMENU;
            }
		}

		static void draw()
		{
			textout_centre_ex(buffer, font, "CONGRATULATIONS", 80, 20, makecol(255,255,255), -1);
			textout_centre_ex(buffer, font, "TO TEAM", 80, 35, makecol(255,255,255), -1);
			textout_centre_ex(buffer, font, getName(progressdatas[curteam].namedat).c_str(), 80, 50, makecol(255,255,255), -1);
			textout_centre_ex(buffer, font, "YOU HAVE FINISHED", 80, 65, makecol(255,255,255), -1);
			textout_centre_ex(buffer, font, "THE GAME", 80, 80, makecol(255,255,255), -1);
		}
	};

int endmenutimer;

class TitleLoop
	{
	public:
		static bool begin;
		static unsigned int selected;
		static bool upheld;
		static bool downheld;
		static bool spaceheld;
	public:
		static void initialize()
		{
			endmode=false;
			endmenutimer=0;
			playmusic(5);
			begin=false;
			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;
			showstory=false;

		}

		static void logic()
		{

			if (endmenutimer>0)
			{
				endmenutimer--;

				if (endmenutimer==QUICKWAIT)
					stopmusic();

				return;
			}

			if (key[KEY_ESC]&&!escpressed)
				quit=true;
			escpressed=key[KEY_ESC];



			if (key[KEY_UP])
			{
				if (!upheld)
				{
					selected=(selected+2)%3;
					playsample(1);
					upheld=true;
				}
			}
			else
				upheld=false;

			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					selected=(selected+1)%3;
					playsample(1);
					downheld=true;
				}
			}
			else
				downheld=false;

			if (key[KEY_SPACE]||key[KEY_ENTER])
			{
				if (!spaceheld)
				{
					if (selected==0)
					{
						begin=true;
						endmenutimer=40;
						playsample(0);
					}
					else if (selected==1)
					{
						begin=true;
						endmenutimer=40;
						playsample(0);
						showstory=true;
					}
					else
					{
						quit=true;
						playsample(0);
						endmenutimer=40;
					}
				}
			}
			else
				spaceheld=false;

		}

		static bool quitcondition()
		{
			return (quit||begin) && endmenutimer==0;
		}

		static void draw()
		{
            clear_to_color(buffer,black);

			textout_centre_ex(buffer, font, "Goal Game", SCREEN_WIDTH/2, 20, white, -1);
			if ( (endmenutimer>0 && endmenutimer<10))
			{
				return;
			}

			if (selected==0)
			{
				if (endmenutimer%2==0)
				textout_ex(buffer,font,"START",100,60,makecol(100,100,100),makecol(255,255,255));
				textout_ex(buffer,font,"Instructions",100,72,makecol(255,255,255),-1);
				textout_ex(buffer,font,"Exit",100,84,makecol(255,255,255),-1);
			}
			else if (selected==1)
			{
				textout_ex(buffer,font,"Start",100,60,makecol(255,255,255),-1);

				if (endmenutimer%2==0)
				textout_ex(buffer,font,"INSTRUCTIONS",100,72,makecol(100,100,100),makecol(255,255,255));
				textout_ex(buffer,font,"Exit",100,84,makecol(255,255,255),-1);
			}
			else
			{
				textout_ex(buffer,font,"Start",100,60,makecol(255,255,255),-1);
				textout_ex(buffer,font,"Instructions",100,72,makecol(255,255,255),-1);

				if (endmenutimer%2==0)
				textout_ex(buffer,font,"EXIT",100,84,makecol(100,100,100),makecol(255,255,255));
			}

		}

	};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;
int endtimer=0;

void winlevel()
{
	if (endtimer>0)
		return;

	endtimer=120;
	playmusic(6);

}

void loselevel()
{
	stopmusic();
	endtimer=120;
}


float distsq(Pos a, Pos b)
{
	return ((b.x-a.x)*(b.x-a.x)+(b.y-a.y)*(b.y-a.y));
}
const int MAX_INFLUENCE=30;

bool presseda,pressedb;

void calcscores()
{
	bool modified=false;
	score[0]=0;
	score[1]=0;
	for (int i=0;i<CIRCLECOUNT;i++)
	{
		if (distsq(base[0],circles[i])<BASERADIUS*BASERADIUS)
		{
			score[0]++;
			modified=true;
		}
		if (distsq(base[1],circles[i])<BASERADIUS*BASERADIUS)
		{
			score[1]++;
			modified=true;
		}
	}
}

void modifytext()
{
	calcscores();
	sprintf(scoretxt1,"p1: %d (%d/3)",score[0],influencedcount[0] );
	sprintf(scoretxt2,"p2: %d (%d/3)",score[1],influencedcount[1] );
}



template<class T>
void loop()
{

    save();
    clear_keybuf();
	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			if (key[KEY_ESC])
            {
                if (gamestate!=GS_INTRO_GAMENAME && gamestate!=GS_INTRO_SCORES);
                {
                    gamestate=GS_INTRO_GAMENAME;
                    return;
                }
            }

			T::logic();

			speed_count--;

    		T::draw();

		}

        rest(100/FRAME_RATE);

        if (!key[KEY_ESC])
        {
            for (int i=0;i<200;i++)
            {
                putpixel(buffer, rand()%160, rand()%120, makecol(rand()%255,rand()%255,rand()%255));
            }
        }
        stretch_blit(buffer, screen, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0, 640, 480);

	}

    save();
}

template<GameState gs>
class StateLoop
    {
        static void initialize();
        static void quitcondition();
        static void draw();
	};


template<GameState gs>
void stateloop()
{
	loop<StateLoop<gs> >();
}

void init()
{

    edittext.reserve(100);
    iter = edittext.begin();   // string iterator

	/* initialise everything */
	allegro_init();
	init_sound();

	gamestate=GS_INTRO_GAMENAME;
    initmenus();

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	#ifdef __APPLE__
	CGDisplayHideCursor(kCGDirectMainDisplay);
	#endif

	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(FRAME_RATE));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;

	red=makecol(255,0,0);
	magenta=makecol(255,0,255);
	black=makecol(0,0,0);
	white=makecol(255,255,255);
	blue=makecol(0,0,255);
	yellow=makecol(255,255,0);
	green=makecol(0,255,0);

	//load save data


	//init the buffer
	buffer=create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);

    load();
    curteam=-1;

}

int dir;
int px;
int py;

int main(int argc, char *argv[])
{

	init();

	while (quit==false)
	{
        cout<<GameStateName[gamestate]<<","<<playeraddition<<endl;
		switch (gamestate) {
			case GS_INTRO_GAMENAME:
				loop<IntroLoop1>();
				break;
			case GS_INTRO_SCORES:
				loop<IntroLoop2>();
				break;
			case GS_TITLE_NEWGAMEMENU:
                SelectLoop::s=&newgamemenu;
                loop<SelectLoop>();
                if (gamestate==GS_TITLE_NEWGAMEMENU)
                {
                    if (menuresult==0)
                        gamestate=GS_TITLE_PLAYERNUMSELECT;
                    else
                        gamestate=GS_CONTINUE_ENTERTEAMNAME;
                }
				break;
			case GS_TITLE_PLAYERNUMSELECT:
                SelectLoop::s=&playercountmenu;
                loop<SelectLoop>();
                if (gamestate==GS_TITLE_PLAYERNUMSELECT)
                {
                    if (menuresult==0)
                    {
                        gamestate=GS_TITLE_WELCOME;
                        playeraddition=false;
                        tempteamtype=0;
                    }
                    else
                    {
                        playeraddition=false;
                        gamestate=GS_TITLE_RELATIONSHIPSELECT;
                    }
                }
				break;
			case GS_TITLE_RELATIONSHIPSELECT:
                SelectLoop::s=&relationshipmenu;
                loop<SelectLoop>();
                if (gamestate==GS_TITLE_RELATIONSHIPSELECT)
                {
                    if (playeraddition)
                    {
                        tempteamtype=menuresult+1;
                        progressdatas[curteam].task=start[tempteamtype];
                        progressdatas[curteam].score++;
                        progressdatas[curteam].confirmationseen=false;
                        gamestate=GS_GAME_LEVELX;
                        playeraddition=false;
                        save();
                    }
                    else
                    {
                        gamestate=GS_TITLE_WELCOME;
                        tempteamtype=menuresult+1;
                    }
                }
				break;
			case GS_TITLE_WELCOME:
				loop<WelcomeLoop>();
                if (gamestate==GS_TITLE_WELCOME)
                    gamestate=GS_GAME_LEVELX;
				break;
			case GS_CONTINUE_ENTERTEAMNAME:
                loop<TextEntryLoop>();
				break;
			case GS_CONTINUE_NAMENOTFOUND:
                loop<NameNotFoundLoop>();
                if(gamestate==GS_CONTINUE_NAMENOTFOUND)
                    gamestate=GS_CONTINUE_ENTERTEAMNAME;
				break;
			case GS_CONTINUE_WELCOMEBACK:
                loop<WelcomeBackLoop>();
                if(gamestate==GS_CONTINUE_WELCOMEBACK)
                    gamestate=GS_GAME_CONFIRMATION;
				break;
			case GS_GAME_LEVELX:
				loop<LevelIntroLoop>();
                if (gamestate==GS_GAME_LEVELX)
                    gamestate=GS_GAME_DESCRIPTION;
				break;
			case GS_GAME_DESCRIPTION:
				loop<LevelDescriptionLoop>();
                if (gamestate==GS_GAME_DESCRIPTION)
                {
                    gamestate=GS_GAME_LOGBACKIN;
                }
				break;
			case GS_GAME_LOGBACKIN:
				loop<CallBackLoop>();
                if (gamestate==GS_GAME_LOGBACKIN)
                    gamestate=GS_GAME_GOODLUCK;
				break;
			case GS_GAME_GOODLUCK:
				loop<GoodLuckLoop>();
                if (gamestate==GS_GAME_GOODLUCK)
                    gamestate=GS_INTRO_GAMENAME;
				break;
			case GS_GAME_CONFIRMATION:
                loop<ConfirmationLoop>();
                if (gamestate==GS_GAME_CONFIRMATION)
                    gamestate=GS_GAME_GAMEOVER;
				break;
			case GS_GAME_GAMEOVER:
                loop<GameOverLoop>();
                if (gamestate==GS_GAME_GAMEOVER)
                    gamestate=GS_GAME_LOGBACKIN;
				break;
			case GS_GAME_SUCCESS:
                loop<SuccessLoop>();
                if (gamestate==GS_GAME_SUCCESS)
                {
                    if (playeraddition)
                    {
                        gamestate=GS_TITLE_RELATIONSHIPSELECT;
                    }
                    else
                    {
                        gamestate=GS_GAME_LEVELX;
                    }
                }
                //IF player count has gone from 1 to 2, should go to relationship
				break;
			case GS_GAME_GAMEOVER_SUCCESS:
                loop<GameoverSuccessLoop>();
                if (gamestate==GS_GAME_GAMEOVER_SUCCESS)
                    gamestate=GS_INTRO_GAMENAME;
                //IF player count has gone from 1 to 2, should go to relationship
				break;
		}
	}

}
END_OF_MAIN()
